Type to search.

Create an inference endpoint

Auth The Elastic Stack includes Elastic's core products such as Elasticsearch, Kibana, Logstash, and Beats. Availability Generally available since 8.11 This functionality is generally available and ready for production usage. Unless stated otherwise on the page, this functionality is available when your Elastic Stack is deployed on Elastic Cloud Hosted, Elastic Cloud Enterprise, Elastic Cloud on Kubernetes, and self-managed environments. This documentation corresponds to the latest patch available for each minor version. If you're not using the latest patch, check the release notes for changes.
Important

The inference APIs enable you to use certain services, such as built-in machine learning models (ELSER, E5), models uploaded through Eland, Cohere, OpenAI, Mistral, Azure OpenAI, Google AI Studio, Google Vertex AI, Anthropic, Watsonx.ai, or Hugging Face. For built-in models and models uploaded through Eland, the inference APIs offer an alternative way to use and manage trained models. However, if you do not plan to use the inference APIs to use these models or if you want to use non-NLP models, use the machine learning trained model APIs.

The following integrations are available through the inference API. You can find the available task types next to the integration name:

  • AI21 (chat_completion, completion)
  • AlibabaCloud AI Search (completion, rerank, sparse_embedding, text_embedding)
  • Amazon Bedrock (chat_completion, completion, text_embedding)
  • Amazon SageMaker (chat_completion, completion, rerank, sparse_embedding, text_embedding)
  • Anthropic (chat_completion, completion)
  • Azure AI Studio (completion, rerank, text_embedding)
  • Azure OpenAI (chat_completion, completion, text_embedding)
  • Cohere (completion, rerank, text_embedding)
  • DeepSeek (chat_completion, completion)
  • Elasticsearch (rerank, sparse_embedding, text_embedding - this service is for built-in models and models uploaded through Eland)
  • ELSER (sparse_embedding)
  • Fireworks AI (chat_completion, completion, text_embedding)
  • Google AI Studio (completion, text_embedding)
  • Google Vertex AI (chat_completion, completion, rerank, text_embedding)
  • Groq (chat_completion)
  • Hugging Face (chat_completion, completion, rerank, text_embedding)
  • JinaAI (embedding, rerank, text_embedding)
  • Llama (chat_completion, completion, text_embedding)
  • Mistral (chat_completion, completion, text_embedding)
  • Nvidia (chat_completion, completion, text_embedding, rerank)
  • OpenAI (chat_completion, completion, text_embedding)
  • OpenShift AI (chat_completion, completion, rerank, text_embedding)
  • VoyageAI (rerank, text_embedding)
  • Watsonx (chat_completion, completion, rerank, text_embedding)

Required privileges

Cluster privileges manage_inference

Path parameters

task_type enum optional

The task type. Refer to the integration list in the API description for the available task types.

Leave it out to use /_inference/{inference_id}.

Values: sparse_embedding text_embedding rerank completion chat_completion embedding document_extraction decision
inference_id string required

The inference Id

Query parameters

timeout string

Specifies the amount of time to wait for the inference endpoint to be created. The default depends on the task type: 120s for completion and chat_completion, and 30s for all other task types.

Request body

service string required

The service type

service_settings object required

Settings specific to the service

task_settings object

Task settings specific to the service and task type

Response

application/json
service string required

The service type

service_settings object required

Settings specific to the service

task_settings object

Task settings specific to the service and task type

inference_id string required

The inference Id

task_type enum required

The task type

Values: sparse_embedding text_embedding rerank completion chat_completion embedding document_extraction decision